﻿Public Class KeyParsing

    Private keyList As Generic.List(Of String)

    Public Sub New()
        keyList = New Generic.List(Of String)
    End Sub

    Public Sub AddKey(ByVal key As String)
        keyList.Add(key)
    End Sub

    Public Sub PopulateTreeView(ByRef trv As TreeView)
        Dim keySplit() As String = Nothing
        Dim trvNode As TreeNode = Nothing
        For Each key In keyList
            'CBB_NAZIM/C:/Documents and Settings/All Users/Documents/My Pictures/Sample Pictures/Blue hills.jpg
            keySplit = key.Split("/")
            trvNode = Nothing
            For Each keyPart As String In keySplit
                If trvNode Is Nothing Then
                    If trv.Nodes.ContainsKey(keyPart) = False Then
                        trvNode = trv.Nodes.Add(keyPart, keyPart)
                    Else
                        trvNode = trv.Nodes.Find(keyPart, False)(0)
                    End If
                Else
                    If trvNode.Nodes.ContainsKey(keyPart) = False Then
                        trvNode = trvNode.Nodes.Add(keyPart, keyPart)
                    Else
                        trvNode = trvNode.Nodes.Find(keyPart, False)(0)
                    End If
                End If
            Next
            If Not trvNode Is Nothing Then
                'Save key in leaves
                trvNode.Tag = key
            End If
        Next
    End Sub

    Public Sub PopulateTreeView2(ByRef trv As TreeView)
        Dim keySplit() As String = Nothing
        Dim trvNode As TreeNode = Nothing
        Dim keyPart As String = ""
        For Each key In keyList
            'CBB_NAZIM/C:/Documents and Settings/All Users/Documents/My Pictures/Sample Pictures/Blue hills.jpg
            keySplit = key.Split("/")
            trvNode = Nothing
            For i As Integer = 1 To keySplit.Length - 2
                keyPart = keySplit(i)
                If trvNode Is Nothing Then
                    If trv.Nodes.ContainsKey(keyPart) = False Then
                        trvNode = trv.Nodes.Add(keyPart, keyPart)
                    Else
                        trvNode = trv.Nodes.Find(keyPart, False)(0)
                    End If
                Else
                    If trvNode.Nodes.ContainsKey(keyPart) = False Then
                        trvNode = trvNode.Nodes.Add(keyPart, keyPart)
                    Else
                        trvNode = trvNode.Nodes.Find(keyPart, False)(0)
                    End If
                End If
            Next
        Next
    End Sub

End Class
